
Auto Multiple Choice - Bug # 368: OS X AMC 1.2.1 macport build échoue après la mise à jour OpenCV 
3.0.0

Status: Closed Priority: Normal
Author: Joël Brogniart Category:
Created: 06/17/2015 Assignee:
Updated: 04/15/2017 Due date:
Description: Bonjour, un signalement d'échec du build Macports d'AMC 1.2.1 après la mise à jour d'OpenCV 3.0.0 viens 

d'arriver sur https://trac.macports.org/ticket/48074.

Je vais essayer de reproduire ça.

History
06/18/2015 01:48 pm - Joël Brogniart
Le fichier concerné par le problème de link est "@amc-detect.cc@".

La version d'OpenCV installée maintenant par MacPorts est la version 3.0.0 et il y a eu un peu de réorganisation. Il semblerait que pour la version 1.2.1 
dans MacPorts, un simple changement dans le fichier "@Makefile-macports.conf@" résolve le problème.

Il faut y ajouter une nouvelle librairie OpenCV dans les options de compilation et transformer
<pre>GCC_OPENCV=-I$(BASEPATH)/include/opencv -lopencv_core -lopencv_highgui -lopencv_imgproc</pre>
en
<pre>GCC_OPENCV=-I$(BASEPATH)/include/opencv -lopencv_core -lopencv_highgui -lopencv_imgproc -lopencv_imgcodecs</pre>

Je fais quelques tests supplémentaires et demanderai quelques renseignements complémentaires côté MacPorts. Si tout va bien je proposerai un 
patch et une modification du fichier de port. Côté AMC il n'y a rien à changer. 

Par contre, il est probable que cette version d'OpenCV se propage un peu partout et qu'il faille adapter la version actuelle d'AMC. J'ai trouvé le truc à 
changer à partir des informations trouvées dans http://docs.opencv.org/master/db/dfa/tutorial_transition_guide.html.

06/19/2015 08:35 pm - Joël Brogniart
Les tests se sont bien passé. J'ai soumis des modifications du port pour AMC 1.2.1 à MacPorts et les modifications ont été acceptées. Donc tout est 
réglé côté MacPorts.

06/22/2015 02:35 pm - Joël Brogniart
J'ai oublié : pour que le nouveau fichier de définition soit pris en compte sur votre installation, il faut mettre à jour MacPorts avec la commande 
suivante.
<pre>
sudo port selfupdate
</pre>

07/21/2015 02:59 pm - Joël Brogniart
Le problème existe aussi pour la version de développement d'AMC.

07/21/2015 03:29 pm - Alexis Bienvenüe
Est-ce que MacPorts fournit également @pkg-config@, qui permettrait d'utiliser les commandes suivantes ?
<pre>
pkg-config --cflags opencv
pkg-config --libs opencv
</pre>
Il suffirait alors de supprimer les lignes définissant @GCC_OPENCV@ et @GCC_OPENCV_LIBS@ dans @Makefile-macports.conf@.

07/22/2015 09:41 am - Joël Brogniart
Dès que j'ai un moment je jette un œil là dessus, mais j'ai peur de ne pas pouvoir faire de tests dans le journée et après je pourrais rien faire avant le 
mois de septembre, mon avion pour le bout du monde part demain matin ;-)

07/22/2015 01:31 pm - Joël Brogniart
Par contre je vois un problème potentiel qui est lié au fonctionnement de Macports. Un fichier de port Macport (Portfile) contient des informations et 
options qui sont calculées au moment où on demande l'installation du port et certaines informations peuvent ne pas être disponibles car elles sont 
fournies par des outils qui ne seront installés que plus tard car ils sont dans la chaine des dépendences. Je galère en ce moment pour obtenir de 
l'information sur Perl au bon moment quand ils n'est pas installé lors de la demande d'installation d'AMC.

07/22/2015 01:38 pm - Alexis Bienvenüe
Peut-être peut-on s'en sortir avec quelque chose comme @depends_build@ (si je comprends bien 
"ceci":https://guide.macports.org/#reference.dependencies) ?

07/22/2015 01:50 pm - Joël Brogniart
Si opencv n'est utilisé que pour le build d'AMC, c'est là qu'il faut mettre la dépendance à opencv. Pour l'instant j'ai indiqué la dépendance avec 
depends_lib. Mais je ne pense pas que ça résoudra le problème de librairie non trouvée. 

09/15/2015 10:30 am - Joël Brogniart
Alexis Bienvenüe wrote:
> Est-ce que MacPorts fournit également @pkg-config@, qui permettrait d'utiliser les commandes suivantes ?
> [...]
> Il suffirait alors de supprimer les lignes définissant @GCC_OPENCV@ et @GCC_OPENCV_LIBS@ dans @Makefile-macports.conf@.

Je peux ajouter une dépendance à pkg-config pour la phase de construction et supprimer ces lignes. Est-ce que cela suffira ou faut-il d'autres 
modifications ?

09/15/2015 10:33 am - Joël Brogniart
Alexis Bienvenüe wrote:
> Est-ce que MacPorts fournit également @pkg-config@, qui permettrait d'utiliser les commandes suivantes ?
> [...]
> Il suffirait alors de supprimer les lignes définissant @GCC_OPENCV@ et @GCC_OPENCV_LIBS@ dans @Makefile-macports.conf@.

Je peux ajouter une dépendance à pkg-config pour la phase de construction et supprimer ces lignes. Est-ce que cela suffira ou faut-il d'autres 
modifications ?

Pendant que j'y suis avec les ports OpenCV et pkg-config installé, j'obtiens les infos suivantes.
<pre>
bash$ pkg-config --cflags opencv
-I/opt/local/include/opencv -I/opt/local/include 
bash$ pkg-config --libs opencv
-L/opt/local/lib -lopencv_shape -lopencv_stitching -lopencv_objdetect -lopencv_superres -lopencv_videostab -lopencv_calib3d -lopencv_features2d 
-lopencv_highgui -lopencv_videoio -lopencv_imgcodecs -lopencv_video -lopencv_photo -lopencv_ml -lopencv_imgproc -lopencv_flann -lopencv_core 
-lopencv_hal 
</pre>

04/15/2017 03:53 pm - Alexis Bienvenüe
- % Done changed from 0 to 100

- Status changed from New to Closed

Marqué résolu sur MacPorts.
